function buildUCItable
clear
clc

loc_data = '../Data';
load([loc_data, '/DataNames']);

n_rounds = 50;

data_cnt = 1;
n_datasets = length(name_data);
n_methods = 6;
test_ranking = zeros(n_datasets, n_methods);
for data_id = 1 : n_datasets
%     disp(data_id)
    data_name = name_data{data_id};
    load(['result_stats/UCI_test_stats_' data_name]);

    str_loss_scores = [ str_loss_test_exp' str_loss_test_exp_prob' str_loss_test_expC'...
                        str_loss_test_logExp' str_loss_test_consExp' str_loss_test_totalExp'];
    
    m = [  mean(str_loss_test_exp) mean(str_loss_test_exp_prob) mean(str_loss_test_expC)...
           mean(str_loss_test_logExp) mean(str_loss_test_consExp) mean(str_loss_test_totalExp)]; % mean(str_loss_test_MhExp)
    s = [std(str_loss_test_exp) std(str_loss_test_exp_prob) std(str_loss_test_expC) ...
                std(str_loss_test_logExp) std(str_loss_test_consExp) std(str_loss_test_totalExp)...
                 ]/ (sqrt(n_rounds)); %std(str_loss_test_MhExp)

    %%%%% compute avg rank
    [sm , m_I] = sort(m);
    temp_rank = 1;
    for j = 1 : n_methods
        if test_ranking(data_cnt, m_I(j)) == 0
            test_ranking(data_cnt, m_I(j)) = temp_rank;
            temp_add_rank = 1;
            for k = j+1 : n_methods
                [tu , p_val ]= ttest(str_loss_scores(:, m_I(j)), str_loss_scores(:, m_I(k)));
                %                 disp([ m(m_I(j))  sm(k) tu   ])
                if tu == 0
                    if p_val > 0.95
                        test_ranking(data_cnt, m_I(k)) = temp_rank;
                        temp_add_rank = temp_add_rank + 1;
                    end
                end
            end
            temp_rank = temp_rank + temp_add_rank;
        end
    end
    
    
    n_methods = size(m,2);
    [tmp, lowest_index] = min(m, [], 2);
    fprintf('%s ', real_name{data_id});
    
    lowest_index = find(test_ranking(data_cnt,:) == 1);
%     if length(lowest_index) > 4
%         lowest_index = [];
%     end
    
    for i = 1 : n_methods
        if length(find(lowest_index == i)) > 0
            fprintf('& $\\mathbf{%0.2f \\pm %0.2f}$ ', m(i), s(i));
        else
            fprintf('& $%0.2f \\pm %0.2f$ ', m(i), s(i));
        end
    end
    fprintf(' \\\\');
    fprintf('\n \\hline \n');
    data_cnt = data_cnt + 1;
end

avg_rank = mean(test_ranking);
fprintf('\n \\hline \n');
n_methods = size(avg_rank,2);
[tmp, lowest_index] = min(avg_rank, [], 2);
fprintf('%s ', 'Avg. Rank');
for i = 1 : n_methods
    if i == lowest_index
        fprintf('& $\\mathbf{%0.2f}$ ', avg_rank(i));
    else
        fprintf('& $%0.2f$ ', avg_rank(i));
    end
end
fprintf(' \\\\');
fprintf('\n \\hline \n');






