function runUCItest(data_id)
warning off
% data_id = 0;

addpath('../coreCode');
mkdir result_stats;

warning off
data_id = data_id + 1;
loc_data = '../Data';
load([loc_data, '/DataNames']);
data_name = name_data{data_id}

loc_temp= [loc_data '/' data_name '/'];

load([loc_temp 'train_' data_name]);
load([loc_temp 'test_' data_name]);

data = XF;
true_labels = Y;
data_test = XFv;
true_labels_test = Yv;
n_classes = N_class;

max_number_iterations = 100;
n_rounds = 50;

code_type = 'simplex';
boosting_order = 'first';

% weak_learner_type = 'stumps';
n_bins = 50;
weak_learner_type = 'regression';

step_size_search_type = 'binary';
decision_rule_type = 'both';

user_codewords = [];
% n_extra_features = 10 * size(data,2);
n_extra_features = 0;

mkdir('classifiers')
for run_id = 1 : n_rounds

    load(['../Data/rnd_matrix/cost_matrix_' data_name '_' num2str(run_id)])   
	learning_cost_matrix = cost_matrix;
    
    loss_type = 'ConsExp'; exp_id = 1* 100 + run_id;
    [str_loss_test_consExp(run_id), temp(run_id) ] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
                                loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
                                n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
                                data_test, true_labels_test, decision_rule_type);
    
    loss_type = 'exp'; exp_id = 2* 100 + run_id; % leaning cost has no effect in training  just in StrLoss
    [str_loss_test_exp(run_id), str_loss_test_exp_prob(run_id) ] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
                                loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
                                n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
                                data_test, true_labels_test, decision_rule_type);

    loss_type = 'logExp'; exp_id = 3* 100 + run_id;
    [str_loss_test_logExp(run_id), temp] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
        loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
        n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
        data_test, true_labels_test, decision_rule_type);

    loss_type = 'totalExp'; exp_id = 4* 100 + run_id;
    [str_loss_test_totalExp(run_id), temp] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
        loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
        n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
        data_test, true_labels_test, decision_rule_type);

    loss_type = 'exp'; exp_id = 5* 100 + run_id;
    [str_loss_test_expC(run_id), temp] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
        loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
        n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
        data_test, true_labels_test, decision_rule_type);

    loss_type = 'MhExp'; exp_id = 6* 100 + run_id;
    [str_loss_test_MhExp(run_id), temp] = trainCDMCBoost(data_name, data, true_labels, n_classes, boosting_order, weak_learner_type,...
        loss_type, code_type, user_codewords, exp_id, max_number_iterations,...
        n_bins, n_extra_features, learning_cost_matrix, step_size_search_type,...
        data_test, true_labels_test, decision_rule_type);
    disp([run_id str_loss_test_MhExp(run_id)]);
    
%     disp([run_id str_loss_test_logExp(run_id) str_loss_test_exp(run_id)...
%           str_loss_test_exp_prob(run_id) str_loss_test_consExp(run_id)...
%           str_loss_test_totalExp(run_id) str_loss_test_expC(run_id)...
%           str_loss_test_MhExp(run_id) ])
end
% disp('+++++++++++++++++++++++++++++++++++++++++++++++++')
% disp([mean(str_loss_test_logExp)   mean(str_loss_test_exp) mean(str_loss_test_exp_prob)...
%       mean(str_loss_test_consExp)  mean(str_loss_test_totalExp) mean(str_loss_test_expC)...
%       mean(str_loss_test_MhExp)]);
% disp([std(str_loss_test_logExp)   std(str_loss_test_exp) std(str_loss_test_exp_prob)...
%       std(str_loss_test_consExp)  std(str_loss_test_totalExp) std(str_loss_test_expC)...
%       std(str_loss_test_MhExp) ]/ (sqrt(n_rounds)));
  
% load(['result_stats/UCI_test_stats_' data_name])
save(['result_stats/UCI_test_stats_' data_name], 'str_loss_test_exp', 'str_loss_test_logExp',...
    'str_loss_test_exp_prob', 'str_loss_test_totalExp', 'str_loss_test_expC',...
    'str_loss_test_consExp', 'str_loss_test_MhExp');





