function codes = buildSimplexCodewords(n_classes)

codes = [1 -1];
aux_value = norm(codes(:, 1) - codes(:, 2)) ^2;

for i = 1:n_classes-2
    codes = addVertex(codes, aux_value, i);
    aux_value = norm(codes(:, 1) - codes(:, 2)) ^2;
end
% codes = codes';
% checkSimplex(codes);

function new_codes = addVertex(codes, aux_value, code_dim)
% [code_dim, n]=size(A);
code_dim = code_dim + 1;
n = code_dim + 1;
alpha = -1 + (2/aux_value);
beta = sqrt(1 - (alpha^2));
new_codes = zeros(code_dim, code_dim + 1);
new_codes(1, :) = [1 alpha * ones(1, n - 1)];
new_codes(2:end, 2:end) = beta * codes;

function checkSimplex(codes)
m = size(codes,2);
for i = 1 : m
    for j = 1 : m
        code_distances(i,j) = norm(codes(:, i) - codes(:, j));
    end
end
code_norms = sum(codes.^2, 1);
disp(code_distances);
disp(code_norms);
