function grad_1 = cmpFirstGrad(dim_index, projections, loss_type,...
                               repeated_codeworeds, lower_cost_matrix,...
                               codeword_set, true_labels);                        
                                
n_samples = size(projections, 1);
n_classes = size(projections, 2);

if strcmp(loss_type , 'totalExp')
    exp_proj = exp(projections);
    exp_neg_proj = 1 ./ exp_proj;
    t1 = sum(exp_proj .* repeated_codeworeds .* lower_cost_matrix, 2);
    t2 = sum(exp_neg_proj, 2);
    t3 = sum(exp_proj .* lower_cost_matrix, 2);
    t4 = sum(exp_neg_proj .* repeated_codeworeds, 2);
    grad_1 = (t1.*t2 - t3.*t4);
    grad_1 = grad_1 / n_classes;
elseif strcmp(loss_type , 'ConsExp')
    exp_proj = exp(projections);
    grad_1 = sum(exp_proj .* repeated_codeworeds .* lower_cost_matrix, 2);
elseif strcmp(loss_type , 'MhExp')
    exp_proj = exp(projections);
    grad_1 = sum(exp_proj .* repeated_codeworeds .* lower_cost_matrix, 2);
    for i = 1 : length(true_labels)
        tmp = true_labels(i);
        grad_1(i) =  grad_1(i) - repeated_codeworeds(i, tmp) * exp(-projections(i, tmp)) ;
    end
%     grad_1 = grad_1 / (n_classes * n_samples);
elseif strcmp(loss_type , 'soft_max')    
    for i = 1 : n_classes
        tmp_p = projections - repmat(projections(:, i), 1, n_classes);
        probs(:, i ) = 1 ./ sum(exp(tmp_p), 2);
    end   
    m1 = sum(repeated_codeworeds .*lower_cost_matrix .* probs, 2);
    t5 = sum(repeated_codeworeds .* probs, 2);
    t5 = repmat(t5, 1, n_classes);
    m2 = sum(lower_cost_matrix .* probs .* t5 , 2);
    grad_1 = m1 - m2;
else
    true_labels_index = (1 : n_samples)' + (true_labels - 1) * n_samples;
    true_projections = repmat(projections (true_labels_index), 1, n_classes);

    risk_matrix = exp(projections - true_projections);
    risk_matrix = lower_cost_matrix .* risk_matrix;
    codeword_set_dim_index = codeword_set(dim_index, :);
    true_code_dim_index = codeword_set_dim_index(true_labels)';
    num_matrix_mid = - repmat(codeword_set_dim_index, n_samples,1)...
        + repmat(true_code_dim_index, 1, n_classes);
    
    if strcmp(loss_type , 'exp')
        grad_1 = sum(num_matrix_mid .* risk_matrix, 2);
        grad_1 = - grad_1 / n_classes;
    elseif strcmp(loss_type , 'logExp')
        denum_matrix = sum(risk_matrix,2);
        num_matrix = sum(num_matrix_mid .* risk_matrix, 2);
        grad_1 =  - num_matrix ./ denum_matrix;
    end
end

% grad_1 = grad_1 / n_classes;
