function estimate = cmpPredictor(Classifier, data);

n_dimenstions = length(Classifier.dims);
estimate = zeros(size(data,1), n_dimenstions);

if strcmp(Classifier.weak_learner_type, 'regression')
    for i = 1 : n_dimenstions
        for j = 1 : length(Classifier.dims(i).nodes)
            a = Classifier.dims(i).nodes(j).coeff_a;
            b = Classifier.dims(i).nodes(j).coeff_b;
            s = Classifier.dims(i).nodes(j).step_size;
            fn = Classifier.dims(i).nodes(j).feature_num;
            estimate(:,i) = estimate(:,i) + s * (data(:,fn) * a + b);
        end
    end
elseif strcmp(Classifier.weak_learner_type, 'stumps')
    for i = 1 : n_dimenstions
        for j = 1 : length(Classifier.dims(i).nodes)
            thr = Classifier.dims(i).nodes(j).thr;
            p = Classifier.dims(i).nodes(j).polarity;
            c = Classifier.dims(i).nodes(j).step_size;
            u = data(:, Classifier.dims(i).nodes(j).feature_num) - thr;
            fx = (u>=0) - (u < 0);
            estimate(:,i) = estimate(:,i) + p * c * fx;
        end
    end
end