function risk = cmpRisk(projections, true_labels, lower_cost_matrix, loss_type);

n_samples = size(projections, 1);
n_classes = size(projections, 2);

if strcmp(loss_type , 'totalExp') 
    exp_neg_proj_sumed = sum(exp(-projections), 2);
    exp_proj_weighted_sum = sum(exp(projections) .* lower_cost_matrix , 2);
    risk = sum(exp_neg_proj_sumed .* exp_proj_weighted_sum) / (n_samples * n_classes);
    risk = risk / (n_classes - 1);
elseif strcmp(loss_type , 'ConsExp')
    exp_proj = exp(projections);
    m1 = sum( exp_proj .* lower_cost_matrix, 2);
    risk = sum(m1) / (n_classes * n_samples);
elseif strcmp(loss_type , 'MhExp')
    exp_proj = exp(projections);
    m1 = sum( exp_proj .* lower_cost_matrix, 2);
%     true_labels_index = (1:n_samples)' + (true_labels - 1) * n_samples;
%     m1 = m1 + sum(exp(-projections(true_label_index));
    for i = 1 : length(true_labels)
        m1(i) = m1(i) + exp(-projections(i, true_labels(i)));
    end
    risk = sum(m1) / (n_classes * n_samples);
elseif strcmp(loss_type , 'soft_max')  
    for i = 1 : n_classes
        tmp_p = projections - repmat(projections(:, i), 1, n_classes);
        probs(:, i ) = 1 ./ sum(exp(tmp_p), 2);
    end
    m2 = sum(probs .* lower_cost_matrix, 2);
    risk = sum(m2)/ n_samples;
elseif strcmp(loss_type , 'logExp')
    true_labels_index = (1:n_samples)' + (true_labels - 1) * n_samples;
    true_projections = repmat(projections (true_labels_index), 1, n_classes);
    risk_matrix = exp((projections - true_projections));
    risk_matrix = lower_cost_matrix.* risk_matrix;
    risk = sum(log(sum(risk_matrix,2) / n_classes)) / n_samples;
elseif strcmp(loss_type , 'exp')
    true_labels_index = (1:n_samples)' + (true_labels - 1) * n_samples;
    true_projections = repmat(projections (true_labels_index), 1, n_classes);
    risk_matrix = exp((projections - true_projections));
    risk_matrix = lower_cost_matrix .* risk_matrix;
    risk = sum((sum(risk_matrix,2))) / (n_samples * n_classes);
end
    