function grad_2 = cmpSecondGrad(dim_index, projections,...
                               lower_cost_matrix, loss_type,...
                               repeated_codeworeds, repeated_codeworeds_square);
                                
SMALL = 0.000001;
n_classes = size(projections, 2);
exp_proj = exp(projections);
exp_neg_proj = 1 ./ exp_proj;

t1 = sum(exp_proj .* lower_cost_matrix .* repeated_codeworeds, 2);
t2 = sum(exp_neg_proj, 2);
t3 = sum(exp_proj .* lower_cost_matrix, 2);
t4 = sum(exp_neg_proj .* repeated_codeworeds, 2);
t5 = sum(exp_proj .* lower_cost_matrix .* repeated_codeworeds_square, 2);
t6 = sum(exp_neg_proj .* repeated_codeworeds_square, 2);

if strcmp(loss_type , 'exp')
    grad_2 = ( t5.*t2 + t3.*t6 + t1.* t4 ) / n_classes;
elseif strcmp(loss_type , 'log')
    input('not implemneted :')
end

grad_2 = grad_2 .* (abs(grad_2) > SMALL) + SMALL * (abs(grad_2) <= SMALL);