function [str_loss str_loss_bayes] = cmpStrLoss(Classifier, data, true_labels, n_classes, decision_rule_type);

if Classifier.has_extras
    data = data * Classifier.extra_features;
end

predictor = cmpPredictor(Classifier, data);
projections = predictor * Classifier.codeword_set;

predictions = cmpDecisions(projections, 'direct', 'all', Classifier.cost_matrix);
conf_matrix = cmpConfMatrix(true_labels, predictions, n_classes);
str_loss = sum(sum(conf_matrix .* Classifier.cost_matrix)) / sum(conf_matrix(:));
str_loss_bayes = 0;
clear conf_matrix

if strcmp(decision_rule_type, 'both')
    predictions = cmpDecisions(projections, 'prob', 'exp', Classifier.cost_matrix);
    conf_matrix = cmpConfMatrix(true_labels, predictions, n_classes);
    str_loss_bayes = sum(sum(conf_matrix .* Classifier.cost_matrix)) / sum(conf_matrix(:));
end