function [update_node, update_angle, predictor_update] = findBestFeatureRegression(grad_1, grad_2,...
                                                                        data, data2)

n_features = size(data, 2);
rep_grad_2 = repmat(grad_2, 1, n_features);
rep_grad_1 = repmat(grad_1, 1, n_features);
rep_grad_1_2 = repmat(grad_1 .* grad_2, 1, n_features);

aa = sum(rep_grad_2 .* data2);
bb = sum(rep_grad_2 .* data);
cc = repmat (sum(grad_2), 1, n_features);
ee = sum(rep_grad_1_2 .* data );
ff = repmat (sum(grad_2.*grad_1), 1, n_features);

determinant = aa .* cc - bb.^2;
uu = 1 ./ determinant;
coeff_a = uu .* ( ee .* cc - bb .* ff);
coeff_b = uu .* (-bb .* ee + aa .* ff);

II = find(determinant < 1e-9);
for i = II
    coeff_a(i) = 0;
    coeff_b(i) = ff(i) / bb(i);
end
    
l1 = coeff_a .* ee + coeff_b .* ff;
l2 = (coeff_a.^2) .* aa + 2 * coeff_a .* coeff_b .* bb + (coeff_b.^2) .* cc;

loss = (l1.^2) ./ l2;

II = find(l2 ==0);
if length(II) > 0
    loss(II) = 0;
end

[p,q]=max(loss);
update_node.feature_num = q;
update_node.coeff_a = coeff_a(q);
update_node.coeff_b = coeff_b(q);
    

predictor_update = data(:,update_node.feature_num) * update_node.coeff_a  + update_node.coeff_b; %response(:,q);
update_angle = acos((sum(predictor_update.*grad_1)) /...
               (norm(grad_1) * norm(predictor_update))) * (180/pi);


