function [update_node, update_angle, update_predictor] = best_feature_mat3(data, index_map, weights, thr_set)

weight_matrix = zeros(size(data,2), size(thr_set, 2) - 1);
% size(Mat)
for i = 1: length(weights)
    u = index_map(i).set;
    weight_matrix(u) = weight_matrix(u) + weights(i);
end
weight_matrix = cumsum(weight_matrix, 2) - sum(weights)/2;

%%% find best feature and threshold %%%%%
[p0 , q0] = max(abs(weight_matrix));
[p1, q1] = max(p0);

update_node.feature_num = q0(q1);
update_node.thr = thr_set(q0(q1), q1+1);
update_node.polarity = - sign( weight_matrix(q0(q1), q1));
update_node.step_size = 0;

%%% compute fx, dot product and angle %%%%%

fx = zeros(size(weights));
Hist = data(:, update_node.feature_num);
u = Hist - update_node.thr;
fx = (u>=0) - (u < 0);
update_predictor = fx * update_node.polarity;

dot_product = sum(fx .* weights);
norms = norm(weights) * sqrt(length(fx));
update_angle = acosd( dot_product / norms );
