function alpha = findBestStepSize(index, projections, update_projection,...
                                  lower_cost_matrix, loss_type,...
                                  repeated_codeworeds, true_labels);
                              
   step_size = -10 : 0.1 : 0;
   temp_risk_values = zeros( size(step_size));
   for i = 1 : length(step_size)
       temp_proj = projections + step_size(i) * update_projection;
       temp_risk_values(i) = cmpRisk(temp_proj, true_labels, lower_cost_matrix, loss_type);
   end
   [p, q] = min(temp_risk_values);
   alpha = step_size(q);
