function step_size = findBestStepSizeBinary(dim_index, projections, true_labels,...
                                            update_projection,...
                                            lower_cost_matrix,...
                                            loss_type,...
                                            repeated_codeworeds, codeword_set);

if norm(update_projection) == 0
    disp('norm is too small')
    step_size = 0;
    return;
end
                                        
current_risk = cmpRisk(projections, true_labels, lower_cost_matrix, loss_type);
right_side_c = 0;

left_side_c = 0;
% upper_risk = current_risk;
% while upper_risk <= current_risk
%     left_side_c = left_side_c *2
%     temp_proj = projections + left_side_c * update_projection;
%     upper_risk = cmpRisk(temp_proj, true_labels, lower_cost_matrix, loss_type);
% end

temp_proj = projections;
grad_1 = cmpFirstGrad(dim_index, temp_proj, loss_type,...
                               repeated_codeworeds, lower_cost_matrix,...
                               codeword_set, true_labels);
dervative_mc = sum(grad_1 .* update_projection(:, dim_index));
while dervative_mc > 0
    left_side_c = left_side_c - 10;
    temp_proj = projections + left_side_c * update_projection;
    grad_1 = cmpFirstGrad(dim_index, temp_proj, loss_type,...
        repeated_codeworeds, lower_cost_matrix,...
        codeword_set, true_labels);
    dervative_mc = sum(grad_1 .* update_projection(:, dim_index));
    if left_side_c < -1000
        break;
    end
end
    



while (right_side_c - left_side_c > 0.001)
    middle_c = (right_side_c + left_side_c )/2;
    temp_proj = projections + middle_c * update_projection;

    grad_1 = cmpFirstGrad(dim_index, temp_proj, loss_type,...
                               repeated_codeworeds, lower_cost_matrix,...
                               codeword_set, true_labels);

    dervative_mc = sum(grad_1 .* update_projection(:, dim_index));
    
    if abs(dervative_mc) < 0.00000001
        break;
    end
    
    if dervative_mc > 0
        right_side_c = middle_c;
    else
        left_side_c = middle_c;
    end
end
step_size = middle_c;